vec3 trace_godrays(vec3 ScreenPos, vec3 LightPos, vec3 LightColor) {
    if(LightColor == vec3(0)) return vec3(0);

    vec3 LightPosScreen = view_screen(LightPos);

    float Dist = 1-pow(distance(LightPosScreen.xy, ScreenPos.xy), 0.3);
    if(Dist < 0) return vec3(0);
    LightColor *= Dist;
    
    // Trace
    vec3 Offset = (ScreenPos-LightPosScreen)/GODRAYS_QUALITY;
    float Noise = dither(gl_FragCoord.xy);
    vec3 ExpectedPos = LightPosScreen+Offset*Noise;
    float LightFactor = 0;
    for(int i = 1; i <= GODRAYS_QUALITY; i++) {
        
        float RealDepth = get_depth(ExpectedPos.xy);
        
        if(RealDepth == 1) {
            
            LightFactor++;
        }
        ExpectedPos += Offset;
    }
        
    return LightColor*LightFactor/8*GODRAYS_STRENGTH;
}

vec3 godrays(vec3 ScreenPos) {
    vec3 FinalColor = vec3(0);
    if(sunPosition.z < 0) {
        const vec3 SUN_GLARE = to_linear(vec3(0.8, 0.45, 0.0));
        vec3 SunColor = (SUN_DIRECT*dayStrength/3+SUN_GLARE*(sunsetStrength+sunriseStrength));
        FinalColor += trace_godrays(ScreenPos, sunPosition, SunColor);
    }
    else { // Moon
        vec3 MoonColor = (SUN_DIRECT*nightStrength/2);
        FinalColor += trace_godrays(ScreenPos, -sunPosition, MoonColor);
    }
    return FinalColor;
}
