uniform float viewWidth;
uniform float viewHeight;
uniform vec2 texelSize;
uniform int isEyeInWater;
uniform float frameTimeCounter;
uniform float frameTime;
uniform int frameCounter;
uniform vec3 fogColor;
uniform vec3 cameraPosition;
uniform vec4 entityColor;
uniform int worldTime;
uniform float rainStrength;
uniform float temperature;
uniform vec3 sunPosition;
uniform int worldDay;
uniform int heldBlockLightValue;
uniform int heldBlockLightValue2;
uniform float darknessFactor;
uniform float darknessLightFactor;
uniform float blindness;
uniform ivec2 eyeBrightnessSmooth;
uniform vec3 upPosition;
uniform vec3 previousCameraPosition;
uniform int entityId;
uniform float nightVision;
uniform float sunAngleAtHome;
uniform float screenBrightness;

uniform sampler2D colortex0;
uniform sampler2D colortex1;
uniform sampler2D gaux1;
uniform sampler2D depthtex0;
uniform sampler2D depthtex1;
uniform sampler2D noisetex;

uniform mat4 gbufferProjectionInverse;
uniform mat4 gbufferProjection;
uniform mat4 gbufferModelView;
uniform mat4 gbufferModelViewInverse;
uniform mat4 gbufferPreviousModelView;
uniform mat4 gbufferPreviousProjection;

uniform float near;
uniform float far;

flat varying vec3 SUN_DIRECT;
flat varying vec3 SUN_AMBIENT;
flat varying vec3 SKY_TOP;
flat varying vec3 SKY_GROUND;

uniform float timeAngle;
uniform float nightStrength;
uniform float dayStrength;
uniform float sunsetStrength;
uniform float sunriseStrength;
uniform vec2 resolution;
uniform vec3 sunOrMoonPosN;
uniform vec3 sunPosN;

#ifdef DISTANT_HORIZONS
uniform float dhFarPlane;
uniform float dhNearPlane;

uniform sampler2D dhDepthTex;
uniform sampler2D dhDepthTex1;

uniform mat4 dhProjectionInverse;
uniform mat4 dhProjection;

uniform int dhRenderDistance;
#endif

const float sunPathRotation = -30;
const bool colortex0Clear = false;
const bool colortex1Clear = false;
#if TAA_MODE != 0
const bool gaux1Clear = false;
#endif
const int noiseTextureResolution = 256;

/*
const int colortex0Format = R11F_G11F_B10F;
const int colortex1Format = R11F_G11F_B10F;
const int gaux1Format = R11F_G11F_B10F;
*/
