#include "/lib/all_the_libs.glsl"

#include "/global/sky.glsl"
#include "/global/fog.glsl"

#ifdef FANCY_CLOUDS
void main() {
	discard;
}
#else
uniform sampler2D texture;

varying vec2 texcoord;
varying vec4 glcolor;

void main() {
	vec4 Color = texture2D(texture, texcoord) * glcolor;
	Color.rgb = to_linear(Color.rgb);

	#ifdef BORDER_FOG
	vec3 ScreenPos = vec3(gl_FragCoord.xy/resolution, gl_FragCoord.z);
	vec3 ViewPos = to_view_pos(ScreenPos);
	vec3 ViewPosN = normalize(ViewPos);
	vec3 PlayerPos = to_player_pos(ViewPos);


	float HorizontalDist = length(PlayerPos.xz);

	vec3 SkyColor = get_sky(ViewPosN, get_sun_glare(distance(ViewPosN, sunPosN)));

	// Note for future self: Clouds don't really work well with DH
	Color.rgb = get_border_fog(HorizontalDist/far, Color.rgb, SkyColor);
	#endif

	/* DRAWBUFFERS:0 */
	gl_FragData[0] = Color; //gcolor
}
#endif
