#include "/lib/all_the_libs.glsl"
#include "/global/lighting.vsh"

flat varying mat3 TBN;
attribute vec4 at_tangent;

void main() {
    init_generic();

    #ifdef WAVY_PLANTS
    if (ViewPos.z > -64 && material == 10002) {
        vec3 WorldPos = to_player_pos(ViewPos);
        WorldPos += cameraPosition;

        if (fract(WorldPos.y + 0.005) > 0.15) {
            vec3 WavePos = WorldPos / WAVE_SIZE + frameTimeCounter * WAVE_SPEED;
            WavePos = sin(WavePos);
            float Noise = WavePos.x * WavePos.y * WavePos.z;
            Noise *= 0.05 + rainStrength * 0.1;

            WorldPos.y += Noise;

            WorldPos -= cameraPosition;
            WorldPos = mat3(gbufferModelView) * WorldPos;
            gl_Position = gl_ProjectionMatrix * vec4(WorldPos, 1);
        }
    }
    #endif

    vec3 binormal = normalize(gbufferModelView[2].xyz);
    vec3 tangent = normalize(gbufferModelView[0].xyz);
    TBN = mat3(tangent, binormal, Normal);

    #if TAA_MODE >= 2
    gl_Position.xy += jitterOffsets[int(framemod8)] * gl_Position.w / resolution;
    #endif
}
